
class Problem
{
public:
	Problem()
	{
		answer = NULL;
		stage = NULL;
	}
	
	~Problem()
	{
		delete answer;
		delete stage;
	}
	
	void Initialize(Rand &rand_, char width_, char height_);
	void Create(StageInfo &info, int *count);

private:
	char width;
	char height;
	Stage *answer;
	Stage *stage;
	char stageHist[MAX_BOAT_SIZE];
	char stageHint[MAX_BOARD_SIZE * 2];
	Rand *rand;
	
	void Reset();
	int SearchBoatSpace(int size, bool vertical, int *und);
	bool SetBoat(int size, int *und);
	bool SetBoatList();
	int CalcHintLine(int pos, int diff, int size);
	bool CalcHint();
	bool SearchPreset(int boatRatio, int seaRatio);
	bool RemovePreset(int loop, int presetRatio);
	bool GetProblem(StageInfo &info, int *count);
};

void CreateProblem(Rand &rand, char width, char height, StageInfo &info, 
	int *count);

