
#include "bridge_creator.h"

static const char *DISP[] = {
	"@", "|", "", "b", "a",
	"O", "P", "Q", "R", "S",
	"T", "U", "V", "W", 
};

void DumpResult(Stage &stage)
{
	static const byte X[5] = {
		0, 1, 2, 0, 0, 
	};
	static const byte Y[5] = {
		0, 0, 0, 1, 2, 
	};
	
	for(int y = 1; y < stage.height - 1; y++){
		for(int x = 1; x < stage.width - 1; x++){
			byte status = stage.status[y * stage.width + x];
			if(status >= HINT_0){
				status += X[stage.status[y * stage.width + x - 1]] + 
				X[stage.status[y * stage.width + x + 1]] + 
				Y[stage.status[(y - 1) * stage.width + x]] + 
				Y[stage.status[(y + 1) * stage.width + x]];
			}
			if(status == BLANK){
				byte line = stage.lineInfo[y * stage.width + x];
				if(line == (LINE_12 << 2)){
					status = YLINE1;
				}else if(line == LINE_12){
					status = XLINE1;
				}
			}
			
			printf("%s", DISP[status]);
		}
		printf("\n");
	}
	printf("\n");
}

void DumpResult(byte *stage, char width, char height)
{
	static const byte X[5] = {
		0, 1, 2, 0, 0, 
	};
	static const byte Y[5] = {
		0, 0, 0, 1, 2, 
	};
	
	for(int y = 1; y < height - 1; y++){
		for(int x = 1; x < width - 1; x++){
			byte status = stage[y * width + x];
			if(status >= HINT_1){
				status = HINT_0 + X[stage[y * width + x - 1]] + 
				X[stage[y * width + x + 1]] + 
				Y[stage[(y - 1) * width + x]] + 
				Y[stage[(y + 1) * width + x]];
			}else if(status == HINT_0){
				status = BLANK;
			}
			
			printf("%s", DISP[status]);
		}
		printf("\n");
	}
	printf("\n");
}

