
struct HintInfo;
struct CellInfo;

class BlockInfo
{
public:
	BlockInfo(char width_, char height_, Rand *rand_)
	{
		rand = rand_;
		width = width_;
		height = height_;
		status = new byte[width * height];
		prev_len = new byte[(width > height) ? width : height];
	}
	
	~BlockInfo()
	{
		delete[] status;
		delete[] prev_len;
	}
	
	bool Create();
	void GetProblem(Stage &stage, HintInfo *hint, short *hintSize);

private:
	Rand *rand;
	byte *status;
	byte *prev_len;
	char width;
	char height;
	
	int RandLen()
	{
		return (rand->Next(4) == 0) ? 
			rand->Next(7) + 2 : rand->Next(4) + 2;
	}
	
	void SetCell(int pos, bool cellSet);
	void SetCellX(int x, int y, int len, bool cellSet);
	void CheckOrphan(int x, int y);
	bool CheckStage();
	int CheckLen(int sx, int sy);
	bool AdjustLenX(int sx, int sy);
	bool AdjustLenY(int sx, int sy);
};

