
#include "crosssum_creator.h"

static const char *DISP[] = {
	"", "_", "@", "P", "Q", "R", "S", "T", "U", "V", "W", "X", 
};

void DumpResult(Stage &stage)
{
	for(int y = 0; y < stage.height; y++){
		for(int x = 0; x < stage.width; x++){
			int pos = y * stage.width + x;
			word status = stage.status[pos];
			
			if(status == STG_BLK){
				if((y == stage.height - 1 || 
					stage.status[pos + stage.width] == STG_BLK) && 
					(x == stage.width - 1 || 
					stage.status[pos + 1] == STG_BLK)){
					printf("%s", DISP[0]);
				}else{
					printf("%s", DISP[1]);
				}
			}else{
				printf("%s", (Stage::GetCandidateCount(status) == 1) ? 
					DISP[Stage::GetSum(status) + 2] : DISP[2]);
			}
		}
		printf("\n");
	}
	printf("\n");
}

void DumpResult2(Stage &stage, int left)
{
	printf("left=%d\n", left);
	DumpResult(stage);
}

#ifdef OUTPUT_TIMER

static dword _PERF_COUNTER[10];
static LARGE_INTEGER _PERF_TIMER[10];
static LARGE_INTEGER _PERF_TIMER_START[10];

void PerfCounter(int num)
{
	_PERF_COUNTER[num]++;
}

void PerfTimerStart(int num)
{
	QueryPerformanceCounter(&_PERF_TIMER_START[num]);
}

void PerfTimerEnd(int num)
{
	LARGE_INTEGER count;
	QueryPerformanceCounter(&count);
	_PERF_TIMER[num].QuadPart += 
		count.QuadPart - _PERF_TIMER_START[num].QuadPart;
}

void PerfFinish()
{
	LARGE_INTEGER freq;
	QueryPerformanceFrequency(&freq);
	
	for(int i = 0; i < 10 ; i++){
		printf("COUNER[%d]: %d\n", i, _PERF_COUNTER[i]);
		_PERF_COUNTER[i] = 0;
	}
	for(int i = 0; i < 10 ; i++){
		printf("TIMER[%d]: %d\n", i, 
			(dword)(_PERF_TIMER[i].QuadPart * 1000 / freq.QuadPart));
		_PERF_TIMER[i].QuadPart = 0;
	}
}

#endif
