
#include "crosssum_creator.h"

#define MAX_BT_SIZE 30

const char Problem::COMB_SIZE[15] = { 34, 20, 14, 12, 12, 4, 8, 14, 12, 10, 4, 
	6, 10, 4, 6, };
const char Problem::COMB2_2[34][2] = {
	{  3,  4 }, {  4,  3 }, {  4,  6 }, {  6,  4 }, { 14, 16 }, { 16, 14 }, 
	{ 16, 17 }, { 17, 16 }, 
	{  3,  4 }, {  4,  3 }, {  4,  6 }, {  6,  4 }, { 14, 16 }, { 16, 14 }, 
	{ 16, 17 }, { 17, 16 }, 
	{  3, 11 }, {  4, 11 }, {  4, 12 }, {  5, 13 }, {  6, 14 }, {  7, 15 }, 
	{  8, 16 }, {  9, 16 }, {  9, 17 }, { 11,  3 }, { 11,  4 }, { 12,  4 }, 
	{ 13,  5 }, { 14,  6 }, { 15,  7 }, { 16,  8 }, { 16,  9 }, { 17,  9 }, 
};
const char Problem::COMB2_3[20][2] = {
	{  4,  7 }, {  4,  7 }, {  4,  7 }, 
	{  3, 19 }, {  4, 19 }, {  4, 20 }, {  5, 21 }, {  6, 22 }, {  7, 23 }, 
	{  8, 23 }, {  8, 24 }, { 12,  6 }, { 12,  7 }, { 13,  7 }, { 14,  8 }, 
	{ 15,  9 }, { 16, 10 }, { 16, 11 }, { 16, 23 }, { 17, 11 }, 
};
const char Problem::COMB2_4[14][2] = {
	{  3, 26 }, {  4, 26 }, {  4, 27 }, {  5, 28 }, {  6, 29 }, {  7, 29 }, 
	{  7, 30 }, { 13, 10 }, { 13, 11 }, { 14, 11 }, { 15, 12 }, { 16, 13 }, 
	{ 16, 14 }, { 17, 14 }, 
};
const char Problem::COMB2_5[12][2] = {
	{  3, 32 }, {  4, 32 }, {  4, 33 }, {  5, 34 }, {  6, 34 }, {  6, 35 }, 
	{ 14, 15 }, { 14, 16 }, { 15, 16 }, { 16, 17 }, { 16, 18 }, { 17, 18 }, 
};
const char Problem::COMB2_6[12][2] = {
	{  3, 37 }, {  4, 37 }, {  4, 38 }, {  5, 38 }, {  5, 39 }, {  6, 38 }, 
	{ 14, 22 }, { 15, 21 }, { 15, 22 }, { 16, 22 }, { 16, 23 }, { 17, 23 }, 
};
const char Problem::COMB2_7[4][2] = {
	{  3, 41 }, {  4, 42 }, { 16, 28 }, { 17, 29 }, 
};
const char Problem::COMB2_8[8][2] = {
	{  3, 43 }, {  3, 44 }, {  4, 42 }, {  4, 44 }, { 16, 36 }, { 16, 38 }, 
	{ 17, 36 }, { 17, 37 }, 
};
const char Problem::COMB3_3[14][2] = {
	{  6, 20 }, {  7, 20 }, {  7, 21 }, {  8, 22 }, {  9, 23 }, { 10, 23 }, 
	{ 10, 24 }, { 20,  6 }, { 20,  7 }, { 21,  7 }, { 22,  8 }, { 23,  9 }, 
	{ 23, 10 }, { 24, 10 }, 
};
const char Problem::COMB3_4[12][2] = {
	{  6, 27 }, {  7, 27 }, {  7, 28 }, {  8, 29 }, {  9, 29 }, {  9, 30 }, 
	{ 21, 10 }, { 21, 11 }, { 22, 11 }, { 23, 12 }, { 23, 13 }, { 24, 13 }, 
};
const char Problem::COMB3_5[10][2] = {
	{  6, 33 }, {  7, 33 }, {  7, 34 }, {  8, 34 }, {  8, 35 }, { 22, 15 }, 
	{ 22, 16 }, { 23, 16 }, { 23, 17 }, { 24, 17 }, 
};
const char Problem::COMB3_6[4][2] = {
	{  6, 38 }, {  7, 39 }, { 23, 21 }, { 24, 22 }, 
};
const char Problem::COMB3_7[6][2] = {
	{  6, 41 }, {  6, 42 }, {  7, 42 }, { 23, 28 }, { 24, 28 }, { 24, 29 }, 
};
const char Problem::COMB4_4[10][2] = {
	{ 10, 28 }, { 11, 28 }, { 11, 29 }, { 12, 29 }, { 12, 30 }, { 28, 10 }, 
	{ 28, 11 }, { 29, 11 }, { 29, 12 }, { 30, 12 }, 
};
const char Problem::COMB4_5[4][2] = {
	{ 10, 34 }, { 11, 35 }, { 29, 15 }, { 30, 16 }, 
};
const char Problem::COMB4_6[6][2] = {
	{ 10, 38 }, { 10, 39 }, { 11, 39 }, { 29, 21 }, { 30, 21 }, { 30, 22 }, 
};

const char Problem::SUM_LUT[2][45] = {
	{
		1, 45, 2, 44, 3, 43, 4, 42, 5, 41, 6, 40, 7, 39, 8, 38, 9, 37, 
		10, 36, 11, 35, 12, 34, 13, 33, 14, 32, 15, 31, 16, 30, 17, 29, 
		18, 28, 19, 27, 20, 26, 21, 25, 22, 24, 23
	}, {
		23, 24, 22, 25, 21, 26, 20, 27, 19, 28, 18, 29, 17, 30, 16, 31, 
		15, 32, 14, 33, 13, 34, 12, 35, 11, 36, 10, 37, 9, 38, 8, 39, 
		7, 40, 6, 41, 5, 42, 4, 43, 3, 44, 2, 45, 1
	}, 
};

void Problem::Initialize(Rand &rand_, char width_, char height_)
{
	rand = &rand_;
	width = width_;
	height = height_;
	left = 0;
	
	stage = new Stage(width, height);
	tempStage = new Stage(width, height);
	block = new BlockInfo(width, height, rand);
	hint = new HintInfo[width * height];
	backTrace = new BackTraceInfo[MAX_BT_SIZE];
	
	for(int i = 0; i < MAX_BT_SIZE; i++){
		backTrace[i].tempStage = new Stage(width, height);
	}
}

void Problem::Reset()
{
	left = 0;
	stage->Reset();
}

bool Problem::UpdateStage(Stage &substage, bool *finished)
{
	Solve solve;
	if(!solve.ProcessOnce(substage, &left)){
		return false;
	}
	
	if(left > 0){
		if(!solve.ProcessSecond(substage, &left)){
			return false;
		}
		if(left > 0){
			return true;
		}
	}
	
	if(!solve.ProcessFirst(substage, false)){
		return false;
	}
	
	*finished = true;
	return true;
}

bool Problem::SetFixedSum(int rate, bool *finished)
{
	int size = width * height;
	rate = rate * width * height / 100;
	int cp = 0;
	
	for(int i = 0; i < size * 2; i++){
		HintInfo *hx = &hint[rand->Next(hintSize)];
		HintInfo *hy = &hint[rand->Next(hintSize)];
		
		while(stage->IsFixedSum(hx->hintPos[0]) || 
			stage->IsFixedSum(hy->hintPos[1])){
			hx = &hint[rand->Next(hintSize)];
			hy = &hint[rand->Next(hintSize)];
		}
		
		int xStart = hx->pos % width;
		int xEnd = xStart + hx->len[0];
		int yPos = hx->pos / width;
		int yStart = hy->pos / width;
		int yEnd = yStart + hy->len[1];
		int xPos = hy->pos % width;
		
		if(yPos <= yStart || yPos > yEnd || xPos <= xStart || xPos > xEnd){
			continue;
		}
		
		int len0;
		int len1;
		bool swap;
		if(hx->len[0] > hy->len[1]){
			swap = true;
			len0 = hy->len[1];
			len1 = hx->len[0];
		}else{
			swap = false;
			len0 = hx->len[0];
			len1 = hy->len[1];
		}
		
		const char *combPtr = NULL;
		if(len0 == 2){
			if(len1 == 2 && rand->Next(4) != 0){
				combPtr = COMB2_2[rand->Next(COMB_SIZE[0])];
			}else if(len1 == 3){
				combPtr = COMB2_3[rand->Next(COMB_SIZE[1])];
			}else if(len1 == 4){
				combPtr = COMB2_4[rand->Next(COMB_SIZE[2])];
			}else if(len1 == 5){
				combPtr = COMB2_5[rand->Next(COMB_SIZE[3])];
			}else if(len1 == 6){
				combPtr = COMB2_6[rand->Next(COMB_SIZE[4])];
			}else if(len1 == 7){
				combPtr = COMB2_7[rand->Next(COMB_SIZE[5])];
			}else if(len1 == 8){
				combPtr = COMB2_8[rand->Next(COMB_SIZE[6])];
			}
		}else if(len0 == 3){
			if(len1 == 3){
				combPtr = COMB3_3[rand->Next(COMB_SIZE[7])];
			}else if(len1 == 4){
				combPtr = COMB3_4[rand->Next(COMB_SIZE[8])];
			}else if(len1 == 5){
				combPtr = COMB3_5[rand->Next(COMB_SIZE[9])];
			}else if(len1 == 6){
				combPtr = COMB3_6[rand->Next(COMB_SIZE[10])];
			}else if(len1 == 7){
				combPtr = COMB3_7[rand->Next(COMB_SIZE[11])];
			}
		}else if(len0 == 4){
			if(len1 == 4){
				combPtr = COMB4_4[rand->Next(COMB_SIZE[12])];
			}else if(len1 == 5){
				combPtr = COMB4_5[rand->Next(COMB_SIZE[13])];
			}else if(len1 == 6){
				combPtr = COMB4_6[rand->Next(COMB_SIZE[14])];
			}
		}
		
		if(combPtr){
			tempStage->Reset(*stage);
			
			if(swap){
				tempStage->SetSum(hx->hintPos[0], combPtr[1]);
				tempStage->SetSum(hy->hintPos[1], combPtr[0]);
			}else{
				tempStage->SetSum(hx->hintPos[0], combPtr[0]);
				tempStage->SetSum(hy->hintPos[1], combPtr[1]);
			}
			
			if(UpdateStage(*tempStage, finished)){
				stage->Reset(*tempStage);
				if(*finished){
					return true;
				}
				if(++cp == rate){
					return true;
				}
			}
		}
	}
	
	return true;
}

bool Problem::SetFixedBlockSub(int hintPos, char sum, int count, 
	bool *finished)
{
	int updated = 0;
	
	if(!stage->UpdateAll2Block(hintPos, sum, count, &updated)){
		return false;
	}
	if(updated == 0){
		return false;
	}
	
	tempStage->Reset(*stage);
	tempStage->SetSum(hintPos, sum);
	
	if(!UpdateStage(*tempStage, finished)){
		return false;
	}
	
	stage->Reset(*tempStage);
	return true;
}

bool Problem::SetFixedBlock(int rate, int count, bool *finished)
{
	int size = width * height;
	rate = rate * hintSize / 100;
	int c = 0;
	
	for(int i = 0; i < size; i++){
		HintInfo &h = hint[rand->Next(hintSize)];
		
		if(rand->Next(2) == 0){
			char len = h.len[0];
			int pos = h.hintPos[0];
			
			if(len >= 2 && len <= 8 && !stage->IsFixedSum(pos)){
				const char *lut = 
					(rand->Next(3) == 0) ? SUM_LUT[0] : SUM_LUT[1];
				
				for(char s = 0; s < 45; s++){
					if(SetFixedBlockSub(pos, lut[s], count, finished)){
						++c;
						break;
					}
				}
			}
		}else{
			char len = h.len[1];
			int pos = h.hintPos[1];
			
			if(len >= 2 && len <= 8 && !stage->IsFixedSum(pos)){
				const char *lut = 
					(rand->Next(3) == 0) ? SUM_LUT[0] : SUM_LUT[1];
				
				for(char s = 0; s < 45; s++){
					if(SetFixedBlockSub(pos, lut[s], count, finished)){
						++c;
						break;
					}
				}
			}
		}
		if(*finished){
			return true;
		}
		if(c == rate){
			return true;
		}
	}
	
	return true;
}


bool Problem::SetFixedBlock2(bool *finished)
{
	Solve solve;
	int updated = 0;
	int left2;
	
	for(int len = 9; len >= 3; len--){
		for(short i = 0; i < hintSize; i++){
			short px = hint[i].hintPos[0];
			short py = hint[i].hintPos[1];
			
			if(hint[i].len[0] == len && !stage->IsFixedSum(px)){
				int minLeft = left;
				char minSum = 0;
				
				for(char s = 1; s <= 45; s++){
					if(stage->UpdateAll2Block(px, s, 1, &updated)){
						tempStage->Reset(*stage);
						tempStage->SetSum(px, s);
						if(solve.ProcessSecond(*tempStage, &left2)){
							if(left2 < minLeft){
								minLeft = left2;
								minSum = s;
							}
						}
					}
				}
				if(minSum == 0){
					return false;
				}
				
				stage->SetSum(px, minSum);
				if(!UpdateStage(*stage, finished)){
					return false;
				}
				if(*finished){
					return true;
				}
			}
			
			if(hint[i].len[1] == len && !stage->IsFixedSum(py)){
				int minLeft = left;
				char minSum = 0;
				
				for(char s = 1; s <= 45; s++){
					if(stage->UpdateAll2Block(py, s, 1, &updated)){
						tempStage->Reset(*stage);
						tempStage->SetSum(py, s);
						if(solve.ProcessSecond(*tempStage, &left2)){
							if(left2 < minLeft){
								minLeft = left2;
								minSum = s;
							}
						}
					}
				}
				if(minSum == 0){
					return false;
				}
				
				stage->SetSum(py, minSum);
				if(!UpdateStage(*stage, finished)){
					return false;
				}
				if(*finished){
					return true;
				}
			}
		}
	}
	
	return true;
}

bool Problem::SetHintSub(int pos, int size)
{
	Stage &prevStage = (pos == 0) ? *stage : *backTrace[pos - 1].tempStage;
	
	Solve solve;
	if(pos == size){
		bool ret = solve.ProcessFirst(prevStage, false);
		if(ret){
			stage->Reset(prevStage);
		}
		
		return ret;
	}
	
	if(!solve.ProcessSecond(prevStage, &left)){
		return false;
	}
	
	short hintPos = backTrace[pos].hintPos;
	
	if(prevStage.IsFixedSum(hintPos)){
		backTrace[pos].tempStage->Reset(prevStage);
		return SetHintSub(pos + 1, size);
	}else{
		for(char s = 0; backTrace[pos].sum[s] != 0; s++){
			int updated = 0;
			if(prevStage.UpdateAll2Block(hintPos, backTrace[pos].sum[s], 1, 
				&updated)){
				backTrace[pos].tempStage->Reset(prevStage);
				backTrace[pos].tempStage->SetSum(hintPos, 
					backTrace[pos].sum[s]);
				
				if(SetHintSub(pos + 1, size)){
					return true;
				}
			}
		}
	}
	
	return false;
}

bool Problem::SetHint()
{
	Solve solve;
	if(!solve.ProcessSecond(*stage, &left)){
		return false;
	}
	
	int count = 0;
	int btSize = 0;
	int updated2 = 0;
	int left2;
	
	for(int len = 9; len >= 1; len--){
		for(short i = 0; i < hintSize; i++){
			short px = hint[i].hintPos[0];
			short py = hint[i].hintPos[1];
			
			if(hint[i].len[0] == len && !stage->IsFixedSum(px)){
				backTrace[btSize].hintPos = px;
				
				int c = 0;
				for(char s = 1; s <= 45; s++){
					if(stage->UpdateAll2Block(px, s, 1, &updated2)){
						tempStage->Reset(*stage);
						tempStage->SetSum(px, s);
						if(solve.ProcessSecond(*tempStage, &left2)){
							backTrace[btSize].sum[c++] = s;
						}
					}
				}
				backTrace[btSize].sum[c] = 0;
				
				if(c == 0){
					return false;
				}else if(c == 1){
					stage->SetSum(px, backTrace[btSize].sum[0]);
				}else{
					if(++btSize == MAX_BT_SIZE){
						return false;
					}
				}
				count += c;
			}
			if(hint[i].len[1] == len && !stage->IsFixedSum(py)){
				backTrace[btSize].hintPos = py;
				
				int c = 0;
				for(char s = 1; s <= 45; s++){
					if(stage->UpdateAll2Block(py, s, 1, &updated2)){
						tempStage->Reset(*stage);
						tempStage->SetSum(py, s);
						if(solve.ProcessSecond(*tempStage, &left2)){
							backTrace[btSize].sum[c++] = s;
						}
					}
				}
				backTrace[btSize].sum[c] = 0;
				
				if(c == 0){
					return false;
				}else if(c == 1){
					stage->SetSum(py, backTrace[btSize].sum[0]);
				}else{
					if(++btSize == MAX_BT_SIZE){
						return false;
					}
				}
				count += c;
			}
		}
	}
	
	if(btSize == 0){
		return solve.ProcessFirst(*stage, false);
	}
	if(count > 80){
		return false;
	}
	
	bool ret = SetHintSub(0, btSize);
	return ret;
}

bool Problem::GetProblem(StageInfo &info)
{
	for(int y = 0; y < height; y++){
		for(int x = 0; x < width; x++){
			int pos = y * width + x;
			
			if(stage->status[pos] == STG_BLK){
				info.problem[pos] = BLOCK;
			}else{
				info.problem[pos] = DIGIT_0;
			}
		}
	}
	
	for(int i = 0; i < hintSize; i++){
		int pos = hint[i].pos;
		info.problem[pos] = HINT;
		
		word num = 0;
		for(int l = 1; l <= hint[i].len[0]; l++){
			int p1 = pos + l;
			num |= stage->status[p1];
		}
		info.hint[pos * 2] = Stage::GetSum(num);
		
		num = 0;
		for(int l = 1; l <= hint[i].len[1]; l++){
			int p1 = pos + l * width;
			num |= stage->status[p1];
		}
		info.hint[pos * 2 + 1] = Stage::GetSum(num);
	}
	
	Solve solve;
	Stage substage(info);
	bool ret = solve.Process(substage, false);
	if(!ret){
		return false;
	}
	
	info.level = solve.GetDifficulty();
	return true;
}

void Problem::Create(StageInfo &info)
{
	bool finished = false;
	
	for( ; ; ){
		for( ; ; ){
			Reset();
			
			if(!block->Create()){
				continue;
			}
			block->GetProblem(*stage, hint, &hintSize);
			DumpProblem(*stage, left);
			
//			break;
			
			if(!SetFixedSum(5, &finished)){
				continue;
			}
			if(finished){
				break;
			}
			
			if(!SetFixedBlock(20, 3, &finished)){
				continue;
			}
			if(finished){
				break;
			}
			
			if(!SetFixedBlock(20, 2, &finished)){
				continue;
			}
			if(finished){
				break;
			}
			
			DumpProblem(*stage, left);
			
			int minLeft = width * height / 3;
			if(minLeft > 100){
				minLeft = 100;
			}
			
			bool ret = true;
			for(int i = 0; i < 10; i++){
				if(!ret || finished || left <= minLeft){
					break;
				}
				ret = SetFixedBlock(5, 1, &finished);
			}
			if(finished){
				break;
			}
			if(!ret || left > minLeft){
				continue;
			}
			
			if(!SetFixedBlock2(&finished)){
				continue;
			}
			if(finished){
				break;
			}
//			DumpProblem2(*stage, left);
			
			if(!SetHint()){
				continue;
			}
			DumpProblem(*stage, left);
			break;
		}
		
		if(!GetProblem(info)){
			continue;
		}
		
		break;
	}
}

void CreateProblem(Rand &rand, char width, char height, StageInfo &info)
{
	info.width = width;
	info.height = height;
	info.problem = new char[width * height];
	info.hint = new char[width * height * 2];
	
	Problem problem;
	problem.Initialize(rand, width, height);
	problem.Create(info);
}
