
struct HintInfo
{
	char len[2];
	short pos;
	short hintPos[2];
};

class BackTraceInfo
{
public:
	Stage *tempStage;
	char sum[22];
	short hintPos;
	
	BackTraceInfo()
	{
		tempStage = NULL;
	}
	
	~BackTraceInfo()
	{
		delete tempStage;
	}
};

class Problem
{
public:
	Problem()
	{
		stage = NULL;
		tempStage = NULL;
		block = NULL;
		hint = NULL;
		backTrace = NULL;
	}
	
	~Problem()
	{
		delete stage;
		delete tempStage;
		delete block;
		delete[] hint;
		delete[] backTrace;
	}
	
	void Initialize(Rand &rand_, char width_, char height_);
	void Create(StageInfo &info);

private:
	char width;
	char height;
	HintInfo *hint;
	short hintSize;
	Stage *stage;
	Stage *tempStage;
	BlockInfo *block;
	BackTraceInfo *backTrace;
	Rand *rand;
	int left;
	
	void Reset();
	bool SetBlock(int blockRetry);
	void SetInfo();
	bool UpdateStage(Stage &substage, bool *finished);
	bool SetFixedSum(int rate, bool *finished);
	bool SetFixedBlock(int rate, int count, bool *finished);
	bool SetFixedBlockSub(int hintPos, char sum, int count, bool *finished);
	bool SetFixedBlock2(bool *finished);
	bool SetHintSub(int pos, int size);
	bool SetHint();
	bool GetProblem(StageInfo &info);
	
	static const char COMB_SIZE[15];
	static const char COMB2_2[34][2];
	static const char COMB2_3[20][2];
	static const char COMB2_4[14][2];
	static const char COMB2_5[12][2];
	static const char COMB2_6[12][2];
	static const char COMB2_7[4][2];
	static const char COMB2_8[8][2];
	static const char COMB3_3[14][2];
	static const char COMB3_4[12][2];
	static const char COMB3_5[10][2];
	static const char COMB3_6[4][2];
	static const char COMB3_7[6][2];
	static const char COMB4_4[10][2];
	static const char COMB4_5[4][2];
	static const char COMB4_6[6][2];
	static const char SUM_LUT[2][45];
};

void CreateProblem(Rand &rand, char width, char height, StageInfo &info);

