
class ColorInfo
{
public:
	ColorInfo() : color(NULL), maxPos(NULL), same(NULL){}
	
	~ColorInfo()
	{
		delete[] color;
		delete[] maxPos;
		delete[] same;
	}
	
	void Initialize(int size)
	{
		this->size = size;
		count = size;
		error = false;
		
		if(!color){
			color = new short[size];
			maxPos = new short[size];
			same = new bool[size];
		}
		
		for(int i = 0; i < size; i++){
			color[i] = (short)i;
			maxPos[i] = (short)i;
			same[i] = true;
		}
	}
	
	void Initialize(ColorInfo &base)
	{
		size = base.size;
		count = base.count;
		error = base.error;
		
		if(!color){
			color = new short[size];
			maxPos = new short[size];
			same = new bool[size];
		}
		
		memcpy(color, base.color, sizeof(short) * size);
		memcpy(maxPos, base.maxPos, sizeof(short) * size);
		memcpy(same, base.same, sizeof(bool) * size);
	}
	
	void Merge(int p0, int p1, bool s)
	{
		if(color[p0] == color[p1]){
			error |= ((same[p0] ^ same[p1]) == s);
		}else{
			if(color[p0] > color[p1]){
				int t = p1;
				p1 = p0;
				p0 = t;
			}
			
			short pc = color[p1];
			bool ps = same[p1];
			
			color[p1] = color[p0];
			same[p1] = !(s ^ same[p0]);
			
			ps ^= same[p1];
			
			for(int i = pc; i <= maxPos[pc]; i++){
				if(color[i] == pc){
					color[i] = color[p0];
					same[i] ^= ps;
				}
			}
			
			if(maxPos[color[p0]] < maxPos[pc]){
				maxPos[color[p0]] = maxPos[pc];
			}
			--count;
		}
	}
	
	bool IsSame(int p0, int p1)
	{
		return (color[p0] == color[p1] && same[p0] == same[p1]);
	}
	
	bool IsDifferent(int p0, int p1)
	{
		return (color[p0] == color[p1] && same[p0] != same[p1]);
	}
	
	bool IsSolved(int p0, int p1){ return color[p0] == color[p1]; }
	int GetColor(int pos){ return color[pos]; }
	bool GetSame(int pos){ return same[pos]; }
	int Count(){ return count; }
	bool HasError(){ return error; }
	
	void GetFixedLoop(char *data)
	{
		for(int i = 0; i < size; i++){
			data[i] = (color[0] == color[i] && same[0] != same[i]) ? 1 : 2;
		}
	}
	
	int GetTryPosition(int pos)
	{
		for(int i = pos; i < size; i++){
			if(color[i] == i){
				return i;
			}
		}
		return -1;
	}

private:
	short *color;
	short *maxPos;
	bool *same;
	int size;
	int count;
	bool error;
};

