
class Loop
{
public:
	Loop() : checked(NULL){}
	
	~Loop()
	{
		delete[] checked;
	}
	
	void Initialize(int size, int dx, int dy)
	{
		this->size = size;
		this->dx = dx;
		this->dy = dy;
		error = false;
		
		if(!checked){
			checked = new char[size];
		}
	}
	
	void Initialize()
	{
		error = false;
	}
	
	bool ClosedCheck(ColorInfo &color)
	{
		error = false;
		color.GetFixedLoop(checked);
		
		bool changed = false;
		int result[3];
		CheckBlock(color, 0, result);
		
		for(int i = 0; i < size; i++){
			if(checked[i] != 0){
				char prev = checked[i];
				result[0] = 0;
				CheckBlock(color, i, result);
				
				if(result[0] <= 1){
					if(!changed){
						for(int j = i + 1; j < size; j++){
							if(checked[j] == 1){
								changed = true;
								break;
							}
						}
					}
					if(changed){
						if(result[0] == 0){
							error = true;
							return false;
						}else{
							color.Merge(result[1], result[2], true);
							return true;
						}
					}
				}
				
				if(prev == 1){
					changed = true;
				}
			}
		}
		
		return false;
	}
	
	bool FinalCheck(ColorInfo &color)
	{
		error = false;
		color.GetFixedLoop(checked);
		
		int result[3];
		result[0] = 0;
		CheckBlock(color, 0, result);
		
		for(int i = 0; i < size; i++){
			if(checked[i] != 0){
				CheckBlock(color, i, result);
				break;
			}
		}
		
		if(result[0] != 0){
			return false;
		}
		for(int i = 0; i < size; i++){
			if(checked[i] != 0){
				return false;
			}
		}
		
		return true;
	}
	
	bool HasError(){ return error; }

private:
	int size;
	int dx;
	int dy;
	bool error;
	char *checked;
	
	void CheckBlock(ColorInfo &color, int pos, int *result)
	{
		if(checked[pos] == 0){
			return;
		}
		checked[pos] = 0;
		
		if(pos + dx < size){
			if(color.IsSame(pos, pos + dx)){
				CheckBlock(color, pos + dx, result);
			}else if(!color.IsDifferent(pos, pos + dx)){
				result[0]++;
				result[1] = pos;
				result[2] = pos + dx;
			}
		}
		
		if(pos - dx >= 0){
			if(color.IsSame(pos, pos - dx)){
				CheckBlock(color, pos - dx, result);
			}else if(!color.IsDifferent(pos, pos - dx)){
				result[0]++;
				result[1] = pos;
				result[2] = pos - dx;
			}
		}
		
		if(pos + dy < size){
			if(color.IsSame(pos, pos + dy)){
				CheckBlock(color, pos + dy, result);
			}else if(!color.IsDifferent(pos, pos + dy)){
				result[0]++;
				result[1] = pos;
				result[2] = pos + dy;
			}
		}
		
		if(pos - dy >= 0){
			if(color.IsSame(pos, pos - dy)){
				CheckBlock(color, pos - dy, result);
			}else if(!color.IsDifferent(pos, pos - dy)){
				result[0]++;
				result[1] = pos;
				result[2] = pos - dy;
			}
		}
	}
};

