
class Solve
{
public:
	void Initialize(const char *hint, int width, int height, Loop &loop);
	void Initialize(Solve &base);
	void ProcessColor1();
	bool ProcessLoop();
	void ProcessRecursive(bool dump, bool *error);
	void Update(int x, int y, char hint);
	
	ColorInfo & GetColor(){ return color; }
	int GetAnswer(){ return answer; }
	int GetTestCount(){ return testCount; }
	int GetTryCount(){ return tryCount; }
	int GetColorCount(){ return colorCount; }
	int GetLoopCount(){ return loopCount; }
	void Dump(){ DumpAnswer(color, stage, width, height); }
	bool IsSolvedPos(int x, int y)
	{
		return stage.IsSolved((y + 1) * width + x + 1); 
	}

private:
	StageInfo stage;
	ColorInfo color;
	Loop *loop;
	int width;
	int height;
	int size;
	int testCount;
	int tryCount;
	int colorCount;
	int loopCount;
	int answer;
	
	bool Process(bool dump, bool *error);
	bool TryOnce(Solve &subSolve);
	void TryTwice(bool dump, bool *error);
};

int SolveProblem(const char *hint, int width, int height);

