
class StageInfo
{
public:
	StageInfo() : stage(NULL), solved(NULL), owned(false){}
	
	~StageInfo()
	{
		if(owned){
			delete[] stage;
		}
		delete[] solved;
	}
	
	void Initialize(const char *hint, int width, int height, int size)
	{
		if(!stage){
			stage = new char[size];
			solved = new bool[size];
			owned = true;
		}
		
		for(int i = 0; i < size; i++){
			stage[i] = -1;
			solved[i] = false;
		}
		
		for(int y = 0; y < height; y++){
			for(int x = 0; x < width; x++){
				if(hint[y * width + x] != 4){
					stage[(y + 1) * (width + 2) + x + 1] = 
						hint[y * width + x];
				}
			}
		}
	}
	
	void Initialize(StageInfo &base, int size)
	{
		if(!stage){
			stage = base.stage;
			solved = new bool[size];
			owned = false;
		}
		memcpy(solved, base.solved, sizeof(bool) * size);
	}
	
	char GetHint(int pos){ return stage[pos]; }
	void SetHint(int pos, char hint){ stage[pos] = hint; }
	
	bool IsSolved(int pos){ return solved[pos]; }
	void Solved(int pos){ solved[pos] = true; }

private:
	char *stage;
	bool *solved;
	bool owned;
};

